<?php

namespace TDevAgency\Cms\Middleware;

use Closure;
use Illuminate\Support\Facades\App;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Config;
use Illuminate\Support\Facades\Redirect;
use Symfony\Component\HttpFoundation\Response;
use TDevAgency\Cms\Models\BaseModels\AdminUserRole;

class AdminAccessMiddleware
{
    /**
     * Handle an incoming request.
     *
     * @param \Illuminate\Http\Request $request
     * @param \Closure $next
     * @return mixed|void
     */
    public function handle($request, Closure $next)
    {

        /**
         * @var AdminUserRole $role
         */
        foreach ($request->user()->roles as $role) {

            if ((is_string($role) && $role === 'admin') || ($role instanceof AdminUserRole && $role->isRole('admin'))) {
                return $next($request);
            }
        }
        return App::abort(Response::HTTP_NOT_FOUND);
    }
}
